// Time_cnt.cpp: implementation of the Time_cnt class.
//
//////////////////////////////////////////////////////////////////////

#include "Time_cnt.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Time_cnt :: Time_cnt ( )
{
//
  time(&t1);  flError=0;  SUMErr=0;
  system_tolerance=0.0000005;
//
	a=5;            /*  (  *) */
	f=0; /*    */
	TIME=0;
	F4=0; /*    */
}

Time_cnt :: ~Time_cnt ( )
{
	if (log_file!=NULL)
	{ time(&t1);
	  //sprintf(mes,"  -> \n%f  = %f ",TIME,TIME/60);
	  issueError (0,"\n#   := %d \n",SUMErr);
	  issueError (0,"\n#End of decode file: %s \n",ctime(&t1));
	  fclose(log_file);
	}

}

/* This function read the numeric string after key letter in success it return 1, otherwice 0*/
int Time_cnt :: read_word(char *s,char w,char *sw)
{   char *word,sym;
    int  n;

    if ((word=strchr(s,w))==NULL) return(0);
    n=0;
    do
    {  sym=*(word+(n+1));
       if (isdigit(sym)||sym==' '||sym=='+'||sym=='-'||sym=='.') n++;
       else break;
    } while (1);
    if (n>0){ strncpy(sw,word+1,n); sw[n]='\0'; return(n); }
    else                                        return(0);
}

/*      up-    f */
int Time_cnt::feed_convert1(int ff)
{
int x,y,f;
if(ff>4000) {ff=ff-4000;F4=1;}
x=ff/100; /* x -       3 */
if(x==4){
	f=(ff-400)/10;
	if(f==0)f=1;
	if(f>9)f=f/10;
	}
else	
{
  y=ff-x*100; /* y -       */
  x=x-5;
  f=y*pow(10,x);
 }
 return f;
}


/*     prev, curr  next.      curr */
double Time_cnt::analiz(void)
{     double t=0, /*    curr */
      t1,t2,t3,s1,s2,s3;
double Vm; /*        */
double V1,V2,V3;
V1=P[i-2].feed/60.0; V2=P[i-1].feed/60.0; V3=P[i].feed/60.0;
/*     ,   0 */
if(P[i-1].span==0.0) return 0;
if(V2==0.0) return 0;

/*       */
if(V2>V1 && V2>V3)
   {
   Vm=sqrt((V1*V1+V3*V3)/2+a*P[i-1].span);
   if(Vm<=V2)
     {
     t1=(Vm-V1)/a; t2=(Vm-V3)/a;
     t=t1+t2; return t;
     }
   t1=(V2-V1)/a; s1=(V2*V2-V1*V1)/(2*a);
   t3=(V2-V3)/a; s3=(V2*V2-V3*V3)/(2*a);
   s2=P[i-1].span-s1-s3;
   t2=s2/V2;
   t=t1+t2+t3; return t;
   } /*    */

/*      */
if(V2>V1 && V2<=V3)
   {
   Vm=sqrt(V1*V1+2*a*P[i-1].span);
   if(Vm<=V3)  {t=(Vm-V1)/a; P[i-1].feed=Vm*60; return t;}
   t1=(V2-V1)/a; s1=(V2*V2-V1*V1)/(2*a);
   s2=P[i-1].span-s1;
   t2=s2/V2;
   t=t1+t2; return t;
   } /*   */

/*      */
if(V2<=V1 && V2>V3)
   {
   if((V2*V2-2*a*P[i-1].span)<=0) Vm=0;  else Vm=sqrt(V2*V2-2*a*P[i-1].span);
   if(Vm>=V3) /* ..    c V2  V3*/
   { t=(V2-Vm)/a; P[i-1].feed=Vm*60; return t; }
   t2=(V2-V3)/a; s2=(V2*V2-V3*V3)/(2*a);
   s3=V3*V3/(2*a); /* ,    
		     0,     
		     V3>0 */
   if(V3==0) t3=0;  else      t3=s3/V3;
   s1=P[i-1].span-s2-s3;
   if(s1>0) t1=s1/V2;  else t1=0;
   t=t1+t2+t3; return t;
   } /*   */

/*      ,   */
return P[i-1].span/V2;
}

/*            kadr */
void Time_cnt::push(char *kadr)
{
float x,y,z;
int ff;
int move=0,feed_set=0;
char word_x[50],word_y[50],word_z[50],word_f[50];
     if (read_word(kadr,'X',word_x)) { sscanf(word_x,"%f",&x); move=1; }  else x=0.0;
     if (read_word(kadr,'Y',word_y)) { sscanf(word_y,"%f",&y); move=1; }  else y=0.0;
     if (read_word(kadr,'Z',word_z)) { sscanf(word_z,"%f",&z); move=1; }  else z=0.0;
     if (read_word(kadr,'F',word_f)) { sscanf(word_f,"%d",&ff); f=feed_convert1(ff); feed_set=1; }

/*      i-  */
 if (feed_set==1) P[i].feed=f;
     else if (i==0) P[i].feed=0;
             else if(move==1) P[i].feed=f;
 if (move==1) P[i].span=sqrt(x*x+y*y+z*z)/100.0; else P[i].span=0;

}


int Time_cnt :: main_Time_cnt(void)
{

  int ii; 
  char mes[70];

   prev=fgets(s_prev,199,inp); i=0; push(prev);
   if(F4==1){curr="N000F0624";F4=0;} else curr=fgets(s_curr,199,inp);
   i++; push(curr);
    if(F4==1){next="N000F0624";F4=0;} else next=fgets(s_next,199,inp);
   i++; push(next);
   if(prev!=NULL)
   do
   {
   TIME=TIME+analiz();
/*             analiz */
    for(i=0;i<=1;i++)
    {
       P[i].feed=P[i+1].feed;
       P[i].span=P[i+1].span;
       }
     if(next==NULL) break;
     if(F4==1){next="N000F0624";F4=0;} else next=fgets(s_next,199,inp);
     push(next);
   }while(1);

  fclose(inp);
 
  sprintf(mes,"  -> \n%f  = %f ",TIME,TIME/60);

  return 0;
}


int Time_cnt:: issueError (int ecode, char *format, ... )
{
   va_list   ap;  char  bufStr[133];bufStr[0]='\0';
   va_start( ap, format );
   if( ecode != 0 )
   {
     SUMErr++;
     if (log_file!=NULL) {
     	//fprintf( log_file, "Error %d: %s\n", ecode, bufStr );
     	switch(ecode)
	{
	case -1: break;
	case -11: break;
	case -21:
         break;
	default: break;
	}
      }
   }
   //vfprintf( log_file, format, ap );
   va_end( ap );
   return(0);
}